#define _GNU_SOURCE
#include <stdlib.h>
#include <stdio.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <sched.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>

typedef long long ll;

void print_localtime(){
    time_t t = time(NULL);
    struct tm tm = *localtime(&t);
    printf("[%d-%02d-%02d %02d:%02d:%02d] ", tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec);
}

int main() {
    const int LEN = 8;
    remove("repro_file");
    int fd = open("repro_file", O_CREAT | O_RDWR, S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH);
    ftruncate(fd, LEN);
    void *ptr = mmap(NULL, LEN, PROT_READ | PROT_WRITE, MAP_SHARED, fd, 0);

    if(ptr == MAP_FAILED){
        printf("mmap failed!\n");
        exit(1);
    }
    ll x = 0;
    for(;;){
        *((ll*)ptr)= x;
        struct timeval t1, t2;
        gettimeofday(&t1, NULL);
        if(msync(ptr, LEN, MS_SYNC|MS_INVALIDATE) != 0){
            printf("msync failed!\n");
            exit(1);
        }

        gettimeofday(&t2, NULL);
        double elapsed = (t2.tv_sec - t1.tv_sec) * 1000.0;
        elapsed += ((t2.tv_usec - t1.tv_usec) / 1000.0);
        if(elapsed > 1000.0){
            print_localtime();
            printf("slow msync: %f ms\n", elapsed);
        }
        x++;
    }

    int ret = munmap(ptr, LEN);
    if(ret == -1){
        printf("munmap failed!\n");
        exit(1);
    }
}
